var __InfoButton = new function() {
    this.duration  = 10;
    this.wait      = 33;
    this.count     = 0;
    this.direction = 0;
    this.timer     = null;
    this.handler   = null;
    this.parent    = null;
    //this.bounds = { left:0, top:0, right:500, bottom:150 };
};

function createInformationButton( parent, x, y, handler, isBlack, zIndex ) {
    __InfoButton.handler = handler;
    if ( zIndex == null ) zIndex = 1000;
    var div = document.createElement( "div" );
    div.style.zIndex = zIndex;
    div.style.width  = "13px";
    div.style.height = "13px";
    if ( x < 0 ) { 
        x = "right:" + (-x) + "px"; 
    } else { 
        x = "left:" + x + "px"; 
    }
    if ( y < 0 ) {
        y = "bottom:" + (-y) + "px";
    } else {
        y = "top:" + y + "px";
    }

    div.setAttribute( "style", "width:13px;height:13px;position:absolute;" 
                      + x + ";" + y + ";z-index:" + zIndex 
                      + ";-apple-dashboard-region:dashboard-region(control circle);" );
    //debug( parent.tagName + " " + parent.id );
    if ( parent == null ) parent = document.firstChild;
    __InfoButton.parent = parent;
//     var style = document.defaultView.getComputedStyle( parent );
//     __InfoButton.bounds.left = parseInt( style.getPropertyValue( "left" ) );
//     __InfoButton.bounds.top = parseInt( style.getPropertyValue( "top" ) );
//     __InfoButton.bounds.right = __InfoButton.bounds.left + parseInt( style.getPropertyValue( "width" ) );
//     __InfoButton.bounds.bottom = __InfoButton.bounds.top + parseInt( style.getPropertyValue( "height" ) );
    parent.appendChild( div );
    parent.addEventListener( "mousemove", __InfoButton_displayButton, true );
    parent.addEventListener( "mouseout", __InfoButton_hideButton, true );

    var src_button;
    var src_rollie;
    if ( isBlack ) {
        src_button = "/System/Library/WidgetResources/ibutton/black_i.png";
        src_rollie = "/System/Library/WidgetResources/ibutton/black_rollie.png";
    } else {
        src_button = "/System/Library/WidgetResources/ibutton/white_i.png";
        src_rollie = "/System/Library/WidgetResources/ibutton/white_rollie.png";
    }

    var rollie = document.createElement( "div" );
    rollie.setAttribute( "id", "flip-rollie" );
    rollie.setAttribute( "style", "width:13px;height:13px;position:absolute;opacity:0;background:url(" + src_rollie + ");" );
    div.appendChild( rollie );

    var info = document.createElement( "div" );
    info.setAttribute( "id", "flip" );
    info.setAttribute( "style", "width:13px;height:13px;position:absolute;opacity:0;background:url(" + src_button + ");" );
    info.addEventListener( "mouseover", __InfoButtonOver, true );
    info.addEventListener( "mouseout",  __InfoButtonOut, true );
    info.addEventListener( "mouseup", __InfoButtonUp, true );
    div.appendChild( info );

}

function __InfoButton_displayButton( event ) {
    if ( __InfoButton.direction == 1 ) {
        return;
    }

    __InfoButton.direction = 1;
    __InfoButton_startAnimation();
}

function __InfoButton_hideButton( event ) {
    var x = event.x;
    var y = event.y;
    var style = document.defaultView.getComputedStyle( __InfoButton.parent );
    if ( style == null ) return;
    var left  = parseInt( style.getPropertyValue( "left" ) );
    var top   = parseInt( style.getPropertyValue( "top" ) );
    var right = parseInt( style.getPropertyValue( "width" ) ) + left;
    var bottom = parseInt( style.getPropertyValue( "height" ) ) + top;

    if ( x >= left && x < right && y >= top && y < bottom ) {
        return;
    }

    if ( __InfoButton.direction == -1 ) {
        return;
    }

    __InfoButton.direction = -1;
    __InfoButton_startAnimation();
}

function __InfoButton_startAnimation() {
    if ( __InfoButton.timer != null ) {
        clearInterval( __InfoButton.timer );
        __InfoButton.timer = null;
    }
    __InfoButton.timer = setInterval( __InfoButton_tickAnimation, __InfoButton.wait );
    __InfoButton_tickAnimation();
}

function __InfoButton_tickAnimation() {
    var info = document.getElementById( "flip" );
    if ( info == null ) {
        clearInterval( __InfoButton.timer );
        __InfoButton.timer = null;
    }
    __InfoButton.count += __InfoButton.direction;

    info.style.opacity = __InfoButton.count / __InfoButton.duration;
    if ( __InfoButton.count <= 0 || __InfoButton.count >= __InfoButton.duration ) {
        clearInterval( __InfoButton.timer );
        __InfoButton.timer = null;
    }
}


function __InfoButtonOver() {
    var div = document.getElementById( "flip-rollie" );
    if ( div ) {
        div.style.opacity = 0.4;
    }
}

function __InfoButtonOut() {
    var div = document.getElementById( "flip-rollie" );
    if ( div ) {
        div.style.opacity = 0;
    }
}

function __InfoButtonUp() {
    var div = document.getElementById( "flip-rollie" );
    if ( div ) {
        div.style.opacity = 0;
    }
    if ( __InfoButton.handler ) {
        __InfoButton.handler();
    }
}
